637624f66a087a8bac278d45ada03966ac787324
[lttng-tools.git] / tests / stress / test_multi_sessions_per_uid_5app_streaming
1 #!/bin/bash
2 #
3 # Copyright (C) - 2013 David Goulet <dgoulet@efficios.com>
4 #
5 # This library is free software; you can redistribute it and/or modify it under
6 # the terms of the GNU Lesser General Public License as published by the Free
7 # Software Foundation; version 2.1 of the License. details.
8 #
9 # You should have received a copy of the GNU Lesser General Public License
10 # along with this library; if not, write to the Free Software Foundation, Inc.,
11 # 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
12
13 CURDIR=$(dirname $0)/
14 TESTDIR=$CURDIR/..
15 LAUNCH_APP="launch_ust_app"
16 SESSION_NAME="stress"
17 EVENT_NAME="tp:tptest"
18 LOG_FILE_SESSIOND="sessiond.log"
19 LOG_FILE_RELAYD="relayd.log"
20 CHANNEL_NAME="channel0"
21 NR_APP=5
22 NR_SESSION=5
23 NR_LOOP=1000
24 COREDUMP_FILE=$(cat /proc/sys/kernel/core_pattern)
25 NUM_TESTS=16
26 APPS_PID=
27
28 TEST_DESC="Stress test - $NR_SESSION sessions per UID streaming with $NR_APP apps"
29
30 source $TESTDIR/utils/utils.sh
31
32 # MUST set TESTDIR before calling those functions
33
34 function enable_channel_per_uid()
35 {
36 local sess_name=$1
37 local channel_name=$2
38
39 $TESTDIR/../src/bin/lttng/$LTTNG_BIN enable-channel --buffers-uid -u $channel_name -s $sess_name >/dev/null 2>&1
40 ok $? "Enable channel $channel_name per UID for session $sess_name"
41 }
42
43 function check_sessiond()
44 {
45 if [ -z "$(pgrep --full lt-lttng-sessiond)" ]; then
46 local str_date=$(date +%H%M%S-%d%m%Y)
47
48 diag "!!!The session daemon died unexpectedly!!!"
49 mv $LOG_FILE_SESSIOND $LOG_FILE_SESSIOND-$str_date
50 if [ -e $COREDUMP_FILE ]; then
51 mv $COREDUMP_FILE $COREDUMP_FILE-$str_date
52 fi
53 exit 1
54 fi
55 }
56
57 function check_relayd()
58 {
59 if [ -z "$(pgrep --full lt-lttng-relayd)" ]; then
60 local str_date=$(date +%H%M%S-%d%m%Y)
61
62 diag "!!!The relay daemon died unexpectedly!!!"
63 mv $LOG_FILE_RELAYD $LOG_FILE_RELAYD-$str_date
64 if [ -e $COREDUMP_FILE ]; then
65 mv $COREDUMP_FILE $COREDUMP_FILE-$str_date
66 fi
67 exit 1
68 fi
69 }
70
71 function start_sessiond()
72 {
73 local SESSIOND_BIN="lttng-sessiond"
74
75 validate_kernel_version
76 if [ $? -ne 0 ]; then
77 fail "Start session daemon"
78 BAIL_OUT "*** Kernel too old for session daemon tests ***"
79 fi
80
81 if [ -z $(pgrep --full lt-$SESSIOND_BIN) ]; then
82 # We have to start it like this so the ulimit -c is used by this
83 # process. Also, we collect any error message printed out.
84 $TESTDIR/../src/bin/lttng-sessiond/$SESSIOND_BIN --quiet --background --consumerd32-path="$TESTDIR/../src/bin/lttng-consumerd/lttng-consumerd" --consumerd64-path="$TESTDIR/../src/bin/lttng-consumerd/lttng-consumerd" >$LOG_FILE_SESSIOND 2>&1
85 status=$?
86 ok $status "Start session daemon"
87 fi
88 }
89
90 function start_relayd
91 {
92 local opt=$1
93 local RELAYD_BIN="lttng-relayd"
94
95 if [ -z $(pgrep --full lt-$RELAYD_BIN) ]; then
96 $TESTDIR/../src/bin/lttng-relayd/$RELAYD_BIN $opt >$LOG_FILE_RELAYD 2>&1 &
97 ok $? "Start lttng-relayd (opt: \"$opt\")"
98 fi
99 }
100
101 test_stress()
102 {
103 for b in $(seq 1 $NR_LOOP); do
104 for a in $(seq 1 $NR_SESSION); do
105 create_lttng_session_uri $SESSION_NAME-$a net://localhost
106 check_sessiond
107 check_relayd
108 enable_channel_per_uid $SESSION_NAME-$a $CHANNEL_NAME
109 check_sessiond
110 check_relayd
111 enable_ust_lttng_event_ok $SESSION_NAME-$a $EVENT_NAME
112 check_sessiond
113 check_relayd
114 start_lttng_tracing_ok $SESSION_NAME-$a
115 check_sessiond
116 check_relayd
117 done
118
119 for a in $(seq 1 $NR_SESSION); do
120 stop_lttng_tracing_ok $SESSION_NAME-$a
121 check_sessiond
122 check_relayd
123 destroy_lttng_session_ok $SESSION_NAME-$a
124 check_sessiond
125 check_relayd
126 done
127 done
128
129 return 0
130 }
131
132 function cleanup()
133 {
134 diag "Cleaning up!"
135 for p in ${APPS_PID}; do
136 kill -s SIGKILL ${p}
137 wait ${p} 2>/dev/null
138 done
139 APPS_PID=
140 stop_lttng_sessiond
141 stop_lttng_relayd
142 }
143
144 function sighandler()
145 {
146 cleanup
147 rm $LOG_FILE_SESSIOND $LOG_FILE_RELAYD
148 exit 1
149 }
150
151 trap sighandler SIGINT
152 trap sighandler SIGTERM
153
154 # Make sure we collect a coredump if possible.
155 ulimit -c unlimited
156
157 # MUST set TESTDIR before calling those functions
158 plan_tests $NUM_TESTS
159
160 print_test_banner "$TEST_DESC"
161
162 TRACE_PATH=$(mktemp -d)
163
164 start_relayd "-o $TRACE_PATH"
165 start_sessiond
166
167 diag "Starting applications launcher"
168
169 # Start NR_APP applications script that will spawn apps non stop.
170 ./$TESTDIR/stress/$LAUNCH_APP $NR_APP &
171 APPS_PID="${APPS_PID} ${!}"
172
173 test_stress
174 out=$?
175 if [ $out -ne 0 ]; then
176 cleanup
177 exit $out
178 fi
179
180 cleanup
181 rm -rf $TRACE_PATH
182 rm $LOG_FILE_SESSIOND $LOG_FILE_RELAYD
183 exit 0
This page took 0.036535 seconds and 4 git commands to generate.